#include<bits/stdc++.h>
using namespace std;
typedef pair<int , int> f;
vector<f> k;

int main(){
    int n, a[32007];
    cin>>n;
    for(int i=1; i<=n; i++){
        cin>>a[i];
    }
    for(int i=n ;i>=1; i--){
        for(int j=n; j>=1; j--){
            if(a[j]<a[j-1]){
                int d=a[j];
                a[j]=a[j-1];
                a[j-1]=d;
                k.push_back({j-1, j});
            }
        }
    }
    cout<<k.size()<<endl;
    for(auto x: k){
        cout<<x.first<<" "<<x.second<<endl;
    }

}